#include<semaphore.h>
#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<pthread.h>
#include <stdint.h>
#include <limits.h>
#include<fcntl.h> 
#include<unistd.h>
#include<string.h>
#include<sys/stat.h>
#include <sys/types.h>

int *fds;
int setSize=4;
int *readCounters;
sem_t *mutex;
sem_t *readerLocks;
sem_t x,y;
pthread_t tid;
pthread_t writerthreads[100],readerthreads[100];
int readercount = 0;

unsigned modulus( unsigned char *num, size_t size, unsigned divisor) {
  unsigned rem = 0;
  
  int i=0;
 while(i<divisor)
 {
     rem+=num[i]%divisor;
     i++;
 }
  return rem%divisor;
}


int file_search(char *key, char *value, int index) {
    lseek(fds[index], 0, SEEK_SET);
    int offset = 0;
    int size;
    char fkey[256];
    char fval[256];
    do {
        size = read(fds[index], fkey, sizeof(fkey));
        if( size <= 0 )
            break; 
        size = read(fds[index], fval, sizeof(fval));
        if( size <= 0 )
            break; 
        if( strcmp(fkey, key)==0 ) {
            if(value) 
                memcpy(value, fval, sizeof(fval));
            return offset;
        }
        offset += sizeof(fkey) + sizeof(fval);
    } while (1);
    return -1;
}

int file_del( char *key)
{   
    int offset;
    int index=modulus(key,256,setSize);
    char fkey[256];
    char fval[256];
    sem_wait(&mutex[index]);
    int found=0;

    offset = file_search(key, NULL, index);
    if(offset >= 0) {
        lseek(fds[index], offset, SEEK_SET);
        memset(fkey, 0, 256);
        memset(fval, 0, 256);
        write(fds[index], fkey, 256);
        write(fds[index], fval, 256);
        found = 1;
    }
    
    sem_post(&mutex[index]);
    return found;
    
}
int file_get(char *key, char *value)
{   
    /* Gets the value stored at offset */
    /* Does not depend on key argument */
    int found =0;
    int index=modulus(key,256,setSize);
    sem_wait(&readerLocks[index]);
    readCounters[index]+=1;
    if(readCounters[index]==1)
        sem_wait(&mutex[index]);
    sem_post(&readerLocks[index]);
    
    if(file_search(key, value, index)>=0) {
        found = 1;
    }
    
    sem_wait(&readerLocks[index]);
    readCounters[index]-=1;
    if(readCounters[index]==0)
    {
        sem_post(&mutex[index]);
    }
    sem_post(&readerLocks[index]);
    return found;
}

void file_put(char *key,char *value) {
     /*
        if found then ask the offset where it is present and if the value noy matches with the present value ,update the given line
        if not present then search for empty line and insert there!
     */
    int offset;
    int index=modulus(key,256,setSize);
    sem_wait(&mutex[index]);

    offset = file_search(key, NULL, index);
    if(offset < 0) {
        lseek(fds[index], 0, SEEK_END);
    } else {
        lseek(fds[index], offset, SEEK_SET);
    }
    write(fds[index], key, 256);
    write(fds[index], value, 256);

    sem_post(&mutex[index]);

}
int storage_init()
{
    /*
        define the array of file descriptors  depending on the prefix 
        define the array of readCount as well as the semaphore (read x and write y) for the same
        PUT,DEL would use write lock 
        GET would use read lock
        each write should return the line number
    */
    fds=(int *)malloc(sizeof(int)*setSize);
    readCounters=(int *)malloc(sizeof(int)*setSize);
    readerLocks=(sem_t *)malloc(sizeof(sem_t)*setSize);
    mutex=(sem_t *)malloc(sizeof(sem_t)*setSize);
    int i=0;
    char fileName[setSize+20];
    for(i=0;i<setSize;i++)
    {
        snprintf(fileName,sizeof(fileName),"File%d.txt",i);
        fds[i]=open(fileName, O_CREAT|O_RDWR,S_IRWXU);
        if(fds[i]<0)
        {
            printf("\n[Unable to Open File%d.txt]\n",i);
        }
        sem_init(&readerLocks[i],0,1);
        sem_init(&mutex[i],0,1);
        readCounters[i]=0;
    }
    return 0;
}
